unit hiButtonEx;

interface

uses Windows,Kol,Share,Win,ShellApi,ActiveX,Messages;

{$I share.inc}

type
 THIButtonEx = class(THIWin)
   private
     procedure _OnClick(Obj:PObj);
     procedure SetCaption(const Value:string);
   public
     _event_onClick:THI_Event;
     _prop_Data:TData;
      procedure _work_doUp(var _Data:TData; Index:word);
      procedure _work_doDown(var _Data:TData; Index:word);
     constructor Create(Parent:PControl);
     procedure _work_doCaption(var _Data:TData; Index:word);
     property _prop_Caption:string write SetCaption;
 end;
   
   
    
implementation

constructor THIButtonEx.Create;
begin
   //Parent.ExStyle := Parent.ExStyle or WS_EX_CONTROLPARENT; 
   inherited Create(Parent);
   Control := NewButton(Parent,'Push');
   Control.OnClick := _OnClick;
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure THIButtonEx._work_doCaption;
begin
   Control.Caption := ReadString(_Data,Null,'');
   //Control.Checked := true;
end;

procedure THIButtonEx._OnClick;
var dt:TData;
begin
   dt := _prop_Data;
  _hi_OnEvent(_event_onClick,dt);
  //_debug(int2str(Control.ExStyle));
end;

procedure THIButtonEx.SetCaption;
begin
  Control.Caption := Value;
end;

procedure THIButtonEx._work_doDown;
begin
 Control.Perform( BM_SETSTATE, 1, 0 ); 
  
end;

 procedure THIButtonEx._work_doUp;
begin
 Control.Perform( BM_SETSTATE, 0, 1 ); 
  
end;

end.
